print("HumanTweaks Mod is running.")
-- these are _G globals. Typing out for clarity.
local CurrentModId = CurrentModId
local CurrentModDef = CurrentModDef
local options = CurrentModDef.options
-- yep. checkin for boss man upstairs.
local DEBUG = true and (SADEnabler and SADEnabler.printtable)
local original_values = nil
local old_options = SADEnabler:shallowcopy(options)


local function Boot()
	print(CurrentModId..': Booting');
	
end

local function Autorun()
	
end

local function ResetMod(id)
	if id and id ~= CurrentModId then
		return
	end
	--print('mod reset')
	
	Boot()
	old_options = SADEnabler:shallowcopy(options)
end

-- events follow..
OnMsg.Autorun = Autorun
OnMsg.ModsReloaded = ResetMod
OnMsg.ApplyModOptions = ResetMod



-- hooks follow..

local UnitRelaxation_CalcRelaxation = UnitRelaxation.CalcRelaxation
local UnitHealth_UpdateMoveSpeed = UnitHealth.UpdateMoveSpeed


UnitRelaxation.CalcRelaxation = function(self, interval)
	if not options.HalfRelaxLoss then
		return UnitRelaxation_CalcRelaxation(interval)
	end

	local routine = RelaxationRoutines[self.relaxation_routine]
	if routine then
		return MulDivRound(routine.Satisfaction, interval, routine.Duration)
	elseif self:IsUnconscious() then
		return MulDivRound(50000 / 2, interval, const.DayDuration)
	elseif not self:IsSleeping() then
		return MulDivRound(-self.RelaxationLossPerDay / 2, interval, const.DayDuration)
	end
end

UnitHealth.UpdateMoveSpeed = function(self)
	local adjust = options.MoveAdjust * 1000
	
	if not IsValid(self) then
		return
	end
	local move_multiplier = Max(self.Movement, 0)
	local move_speed = Max(move_multiplier / 100, self.MaxMoveReduction)
	local nume = move_speed * adjust
	local result = nume / 1000
	--[[
	print('movement: '..tostring(self.Movement))
	print('MaxMoveReduction: '..tostring(self.MaxMoveReduction))
	print('move_multiplier: '..tostring(move_multiplier))
	print('move_speed: '..tostring(move_speed))
	print('adjust: '..tostring(adjust))
	print('nume: '..tostring(nume))
	print('result: '..tostring(result))
	]]--
	self:SetMoveSpeed(result)
end