print("RecipeTweaks Mod is running.")
-- these are _G globals. Typing out for clarity.
local CurrentModId = CurrentModId
local CurrentModDef = CurrentModDef
local options = CurrentModDef.options
-- checkin' for boss man upstairs.
local DEBUG = true and (SADEnabler and SADEnabler.printtable)
-- we need to keep track of what the value is supposed to be..
local original_values = nil
-- and track changes to our own options..
local old_options = SADEnabler:shallowcopy(options)

local function getOriginalsSnapshot()
	original_values = {}
	for key,recipe in pairs(Recipes) do
		local _input = {}
		local _output = {}
		for _,input in ipairs(recipe.InputResources) do 
			_input[_] = SADEnabler:min(input.amount,1000)
		end
		for _,output in ipairs(recipe.OutputResources) do 
			_output[_] = SADEnabler:min(output.amount,1000)
		end
		
		original_values[key] = {
			ActivityDuration = recipe.ActivityDuration,
			input = _input,
			output = _output,
		}
	end
	
	--SADEnabler:printtable(Recipes)
	--SADEnabler:printtable(original_values)
end

local function Boot()
	print(CurrentModId..': Booting');
	
	if DEBUG then
		--SADEnabler:printtable(CurrentModId)
		--SADEnabler:printtable(CurrentModDef)
		--SADEnabler:printtable(options)
		--SADEnabler:printtable(old_options)
	end
	
	if DEBUG then
		--SADEnabler:printtable(Recipes)
		--SADEnabler:printtable(Recipes.MedicineBandages_ScrapCloth)
		for _,output in ipairs(Recipes.MedicineBandages_ScrapCloth.OutputResources) do 
			--SADEnabler:printtable(output)
		end
		
	end
	
	
	if (options.HalfCostEverything) then
		--print('enabling: HalfCostEverything')
		for key,recipe in pairs(Recipes) do 
			for _,input in ipairs(recipe.InputResources) do 
				input.amount = SADEnabler:min(original_values[key].input[_] / options.ResourceFactor, 1000)
			end
		end
	elseif (old_options.HalfCostEverything) then
		--print('disabling: HalfCostEverything')
		for key,recipe in pairs(Recipes) do 
			for _,input in ipairs(recipe.InputResources) do 
				input.amount = original_values[key].input[_]
			end
		end
	end
	
	if (options.DoubleEverything) then
		--print('enabling: DoubleEverything')
		for key,recipe in pairs(Recipes) do 
			for _,output in ipairs(recipe.OutputResources) do 
				output.amount = SADEnabler:min(original_values[key].output[_] * options.ResourceFactor, 1000)
			end
		end
	elseif (old_options.DoubleEverything) then
		--print('disabling: DoubleEverything')
		for key,recipe in pairs(Recipes) do 
			for _,output in ipairs(recipe.OutputResources) do 
				output.amount = original_values[key].output[_]
			end
		end
	end
	
	
	if (options.EnableMoreBandages) then 
		--print('enabling: EnableMoreBandages')
		for _,output in ipairs(Recipes.MedicineBandages.OutputResources) do 
			output.amount = original_values.MedicineBandages.output[_] * options.ResourceFactor
		end
		
		for _,output in ipairs(Recipes.MedicineBandages_ScrapCloth.OutputResources) do 
			output.amount = original_values.MedicineBandages_ScrapCloth.output[_] * options.ResourceFactor
		end
	elseif (old_options.EnableMoreBandages) then 
		--print('disabling: EnableMoreBandages')
		for _,output in ipairs(Recipes.MedicineBandages.OutputResources) do 
			output.amount = original_values.MedicineBandages.output[_]
		end
		
		for _,output in ipairs(Recipes.MedicineBandages_ScrapCloth.OutputResources) do 
			output.amount = original_values.MedicineBandages_ScrapCloth.output[_]
		end
	end
	
	if (options.EnableFasterBandages) then
		--print('enabling: EnableFasterBandages')
		Recipes.MedicineBandages.ActivityDuration = SADEnabler:min(original_values.MedicineBandages.ActivityDuration / options.SpeedFactor, 1000)
		Recipes.MedicineBandages_ScrapCloth.ActivityDuration = SADEnabler:min(original_values.MedicineBandages_ScrapCloth.ActivityDuration / options.SpeedFactor, 1000)
	elseif (old_options.EnableFasterBandages) then
		--print('disabling: EnableFasterBandages')
		Recipes.MedicineBandages.ActivityDuration = original_values.MedicineBandages.ActivityDuration
		Recipes.MedicineBandages_ScrapCloth.ActivityDuration = original_values.MedicineBandages_ScrapCloth.ActivityDuration
	end
	
	if (options.EnableFasterElectronics) then
		--print('enabling: EnableFasterElectronics')
		Recipes.Electronics.ActivityDuration = SADEnabler:min(original_values.Electronics.ActivityDuration / options.SpeedFactor, 1000)
		Recipes.Electronics_Printer.ActivityDuration = SADEnabler:min(original_values.Electronics_Printer.ActivityDuration / options.SpeedFactor, 1000)
	elseif (old_options.EnableFasterElectronics) then
		--print('disabling: EnableFasterElectronics')
		Recipes.Electronics.ActivityDuration = original_values.Electronics.ActivityDuration
		Recipes.Electronics_Printer.ActivityDuration = original_values.Electronics_Printer.ActivityDuration
	end
	
end
local function Autorun()
	
end

local function ResetMod(id)
	if id and id ~= CurrentModId then
		return
	end
	--print('mod reset')
	
	if (original_values == nil) then
		getOriginalsSnapshot()
	end
	Boot()
	old_options = SADEnabler:shallowcopy(options)
end


OnMsg.Autorun = Autorun
OnMsg.ModsReloaded = ResetMod -- Load default/saved settings
OnMsg.ApplyModOptions = ResetMod -- Fired when Mod Options>Apply button is clicked

OnMsg.ChangeGameSpeed = function(new_time_factor, old_time_factor)
	--print('ChangeGameSpeed: '..tostring(old_time_factor)..' -> '..tostring(new_time_factor))
end


--[[

-- some samples follow.. not that they are of particular interest..

OnMsg.NewMapLoaded = function()
	print("NewMapLoaded")
end

OnMsg.LoadGame = function()
	print("LoadGame")
end

OnMsg.DoneMap = function()
	print("DoneMap")
end

OnMsg.GameStarted = function()
	print("GameStarted")
end

OnMsg.GameStateChanged = function()
	print("GameStateChanged")
end

OnMsg.UIReady = function()
	print("UIReady")
end

OnMsg.ModsReloaded = function()
	print("ModsReloaded")
end

OnMsg.DataLoaded = function()
	print("DataLoaded")
end

OnMsg.ChangeMap = function()
	print("ChangeMap")
end

OnMsg.EngineStarted = function()
	print("EngineStarted")
end

OnMsg.PreNewMap = function()
	print("PreNewMap")
end

OnMsg.NewMap = function()
	print("NewMap")
end

OnMsg.NewGame = function()
	print("NewGame")
end

OnMsg.SystemActivate = function()
	print("SystemActivate")
end
OnMsg.AccountStorageChanged = function()
	print("SystemActivate")
end



OnMsg.ClassesGenerate = function()
	print("ClassesGenerate")
end

OnMsg.ClassesPostprocess = function()
	print("ClassesPostprocess")
end

OnMsg.ClassesPreprocess = function()
	print("ClassesPreprocess")
end

]]--
